<template>
	<v-card>
		<v-card-title>{{page_title}}</v-card-title>
		<alert/>
	</v-card>
</template>

<script>
import alert from '../../components/Alert.vue'
import {mapActions, mapGetters} from 'vuex'

export default {
	name:'social-callback',
	components:{alert},
	data(){
		return{
			page_title:'Please wait when Callback happen .....',
			provider:'',
			code:''
		}
	},methods:{
		...mapActions({
			alert:'alert/show',
			loginStorageModule:'authenticate/login',
			setComponent:'component/setComponent'
		}),
		async getToken(){
			try {
				
				console.log('Provider:')
				console.log(this.provider)

				console.log('Code:')
				console.log(this.code)

				let response = await axios.get(`/api/auth/login/social/${this.provider}/callback?${this.code}`)

				if(response.status == 200){

					let {response_code, response_message, data} = response.data

					if(response_code=="00"){

						this.loginStorageModule(data)

						console.log('data:')
						console.log(data)

						this.alert({
							title:'success',
							message:response_message
						})

						this.setComponent({
							component: this.componentName,
							status: false
						})
						this.$emit('closed',false)
						this.$router.push("{name:'home'}")

					}else{

						this.alert({
							title:'error',
							message:'response_message'
						})

					}
				}

			} catch (err) {

				console.log(err)

			}
		}
	},
	computed:{
		...mapGetters({
			whoAmI:'authenticate/whoAmI',
			componentName:'component/getComponent',
			componentStatus:'component/getStatus'
		})
	},
	mounted:function(){
		console.log(this.$router)
		let {provider} = this.$router.currentRoute.params
		let {fullPath} = this.$router.currentRoute
		console.log(`Call back from : ${provider}`)

		this.provider = provider
		this.code = fullPath.split('?')[1]  

		console.log('Do Login .... ')
		this.getToken()
	}
}
</script>

<style>

</style>